import { ChangeDetectionStrategy, ChangeDetectorRef, Component, Optional } from '@angular/core';
import { ColumnDefinitionBuilder } from '../../grid/model/column-definition.builder';
import { AbstractCellRendererComponent } from '../../grid/components/cell-renderers/abstract-cell-renderer/abstract-cell-renderer.component';
import { GridService } from '../../grid/services/grid.service';
import { LinkOptions } from '../../grid/model/column-definition.model';
import { GridWithStatePersistence } from '../../grid/persistence/grid-with-state-persistence';
import { GridColumnId } from '../../../shared/constants/grid/grid-column-id';
import { TranslateService } from '@ngx-translate/core';

/**
 * Cell renderer for links. You must use options to pass the url. Three way are available to provide the url, by priority order :
 * - An url generated by a function (row: DataRow, columnDisplay: ColumnDisplay) => string | string[] you provide
 * - A static url concatenated with a given column value
 * - A static url
 */
@Component({
  selector: 'sqtm-core-link-cell',
  template: `@if (row) {
    <div class="full-width full-height flex-column">
      @if (isDeleted || !getUrl()) {
        <span class="sqtm-grid-cell-txt-renderer m-auto-0">
          {{ textToDisplay | translate }}
        </span>
      } @else {
        <a
          [routerLink]="getUrl()"
          [target]="options.target ?? '_self'"
          class="sqtm-grid-cell-txt-renderer m-auto-0"
          nz-tooltip
          [class.disabled-row]="row.disabled"
          [nzTooltipTitle]="tooltipTitle | translate"
          [nzTooltipPlacement]="'topLeft'"
          (click)="saveGridState()"
          >{{ textToDisplay | translate }}</a
        >
      }
    </div>
  }`,
  styleUrls: ['./link-cell.component.less'],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class LinkCellComponent extends AbstractCellRendererComponent {
  constructor(
    grid: GridService,
    cdr: ChangeDetectorRef,
    @Optional() private gridWithStatePersistence: GridWithStatePersistence,
    private translateService: TranslateService,
  ) {
    super(grid, cdr);
  }

  getUrl(): string | string[] {
    if (!this.options) {
      throw Error('This cell renderer must be provided with LinkOptions.');
    }

    if (this.options.createUrlFunction) {
      return this.options.createUrlFunction(this.row, this.columnDisplay);
    }

    if (this.options.columnParamId) {
      return this.options.baseUrl + '/' + this.row.data[this.options.columnParamId];
    } else {
      return this.options.baseUrl;
    }
  }

  protected get options(): LinkOptions {
    return this.columnDisplay.options as LinkOptions;
  }

  saveGridState() {
    if (this.options && this.options.saveGridStateBeforeNavigate) {
      if (this.gridWithStatePersistence) {
        this.gridWithStatePersistence.saveSnapshot();
      } else {
        const message = `Error, the column ${this.columnDisplay.id} is configured to save grid state before navigation but you don't provide a GridWithStatePersistence`;
        throw Error(message);
      }
    }
  }

  protected get isDeleted() {
    return !this.row.data[this.columnDisplay.id];
  }

  protected get tooltipTitle(): string {
    if (!this.options) {
      throw Error('This cell renderer must be provided with LinkOptions.');
    }
    if (this.options.createTooltipTitleFunction) {
      return this.options.createTooltipTitleFunction(this.row);
    }
    return this.options.tooltipTitle || this.textToDisplay;
  }

  protected get textToDisplay(): string {
    const thisId = this.row.data[this.columnDisplay.id];
    const labelKey = this.options.labelKey;

    if (this.options && labelKey) {
      return this.translateService.instant(labelKey);
    } else if (thisId) {
      return thisId;
    } else {
      return this.options.fallbackStringKey || '-';
    }
  }
}

export function withLinkColumn(id: GridColumnId, options: LinkOptions): ColumnDefinitionBuilder {
  return new ColumnDefinitionBuilder(id).withRenderer(LinkCellComponent).withOptions(options);
}

export function basicLinkColumn(id: GridColumnId): ColumnDefinitionBuilder {
  const options: LinkOptions = { kind: 'link', baseUrl: '', columnParamId: id };
  return new ColumnDefinitionBuilder(id).withRenderer(LinkCellComponent).withOptions(options);
}
